<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:rng="http://relaxng.org/ns/structure/1.0" version="1.0">

    <xsl:template match="*|@*|text()|comment()">
        <xsl:copy>
            <xsl:apply-templates select="*|@*|text()|comment()"/>
        </xsl:copy>
    </xsl:template>

    <xsl:template
        match="rng:element[@name and count(@*) = 1 and (rng:ref or rng:data) and count(*) = 1]">
        <rng:element>
            <xsl:choose>
                <xsl:when test="rng:ref">
                    <xsl:attribute name="name">
                        <xsl:value-of select="concat(@name , '.' ,  rng:ref/@name)"/>
                    </xsl:attribute>
                    <xsl:copy-of select="rng:ref"/>
                </xsl:when>
                <xsl:when test="rng:data">
                    <xsl:attribute name="name">
                        <xsl:value-of select="concat(@name , '.' ,  rng:data/@type)"/>
                    </xsl:attribute>
                    <xsl:copy-of select="rng:data"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:apply-templates select="*|@*|text()|comment()"/>
                </xsl:otherwise>
            </xsl:choose>
        </rng:element>
    </xsl:template>

    <xsl:template match="rng:include[@href and count(@*) = 1 and count(*) = 0]">
        <rng:include href="{concat(substring-before(@href, '.rng'), '.renrng')}"/>
    </xsl:template>

</xsl:stylesheet>
